<template>
    <div id="display-wrapper"></div>
    <div>
        <h1>{{ report.split('/')[report.split('/').length - 1] }}</h1>
        <div id="graph-select-wrapper">
            <p>
                {{
                    entity != ''
                        ? 'Editing ' + entity
                        : 'Creating new entity in'
                }}
            </p>
            <select v-model="selectedGraph" id="graph-selector">
                <option>Adarchive</option>
                <option>Orlando</option>
                <option>Usaskart</option>
            </select>
        </div>

        <hr id="header-splitter" />

        <div id="form-input-wrapper">
            <div
                class="input-wrapper"
                v-for="field in fields"
                :key="field.name"
            >
                <p class="field-label">
                    {{
                        field.name != ''
                            ? field.name + ':'
                            : field.property + ':'
                    }}
                </p>
                <input class="field-input" v-model="field.value" />
            </div>
            <input type="button" value="Submit" v-on:click="submitReport" />
            <input type="button" value="Cancel" v-on:click="getReportFields" />
        </div>
    </div>
</template>

<script lang="ts">
import { Vue, prop } from 'vue-class-component';
import axios from 'axios';

interface Field {
    name: string;
    property: string;
    path: string;
    class: string;
    datatype: string;
    value: string;
}

class Props {
    report = prop({
        type: String,
        required: false,
        default: '',
    });

    entity = prop({
        type: String,
        required: false,
        default: '',
    });
}

export default class FormDisplay extends Vue.with(Props) {
    fields: Array<Field> = [];
    entityUri = '';
    selectedGraph = '';

    mounted() {
        this.getReportFields();
    }

    getReportFields() {
        axios
            .get(
                '/api/forms/get-form?report=' +
                    this.report +
                    '&entity=' +
                    this.entity
            )
            .then((response) => {
                this.fields = response.data.form;
                this.entityUri = response.data.entity;
            })
            .catch((e) => {
                console.log(e);
            });
    }

    submitReport() {
        axios
            .post('/api/forms/submit', {
                entity: this.entityUri,
                graph: this.selectedGraph.toLowerCase(),
                form: this.fields,
            })
            .then(() => {
                this.getReportFields();
            })
            .catch((e) => {
                console.log(e);
            });
    }
}
</script>

<style>
#display-wrapper {
    background-color: gray;
    height: 30vh;
}

#graph-select-wrapper {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
}
#graph-selector {
    margin-left: 8px;
}

#form-input-wrapper {
    height: calc(70vh - 250px);
    margin: auto;
    overflow-y: auto;
}

#header-splitter {
    width: 80%;
}

.input-wrapper {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    margin: auto;
    margin-top: 10px;
    margin-bottom: 10px;
    width: 70%;
}

.field-label {
    margin-right: 10px;
    flex: 1;
}

.field-input {
    height: 30px;
    padding: 5px;
    flex: 6;
}
</style>
